# -*- coding: utf-8 -*-
# Copyright 2016 Earth Sciences Department, BSC-CNS
#

"""calc_median module

This module provide calculation of MEDIAN.

"""

import numpy as np
import json
import os
import os.path
import sys
import subprocess
from datetime import datetime
from dateutil.relativedelta import relativedelta

np.set_printoptions(precision=2)

DIR_PATH = os.path.abspath(os.path.dirname(__file__))
MODELS = json.load(open(os.path.join(DIR_PATH, '../conf/models.json')))
NETCDF_TEMPLATE = "{}/archive/{}{}.nc"

DEBUG = True

lonlat = "-26,60,0,65"
main_output_path = "/data/products/median/"
selected_date = "20220515"

for model in MODELS:
    filepath = NETCDF_TEMPLATE.format(
        MODELS[model]['path'],
        selected_date,
        MODELS[model]['template']
    )
    if model == 'median' or not os.path.exists(filepath):
        continue

    script = "cdo -L -s -sellonlatbox,"+lonlat+" -remapbil,global_0.5  "+filepath+" "+main_output_path+"interpolated/"+os.path.basename(filepath)

    subprocess.call(script, shell=True)
